
Foreman - Bug #6964

Error on startup: "null value in column "user_id" violates not-null constraint"

08/06/2014 12:53 PM - Dominic Cleal

Status: Closed   

Priority: Urgent   

Assignee: Dominic Cleal   

Category: Database   

Target version: 1.6.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/1665

  

Description

Since #6873, Foreman isn't starting up on a clean installation with:

PGError: ERROR:  null value in column "user_id" violates not-null constraint

: INSERT INTO "cached_user_roles" ("created_at", "role_id", "updated_at", "user_id", "user_role_id

") VALUES ($1, $2, $3, $4, $5) RETURNING "id" (ActiveRecord::StatementInvalid)

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapter

s/postgresql_adapter.rb:1171:in `get_last_result'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapter

s/postgresql_adapter.rb:1171:in `exec_cache'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapter

s/postgresql_adapter.rb:665:in `block in exec_query'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapter

s/abstract_adapter.rb:280:in `block in log'

  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/notifications/in

strumenter.rb:20:in `instrument'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapter

s/abstract_adapter.rb:275:in `log'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapter

s/postgresql_adapter.rb:663:in `exec_query'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapter

s/abstract/database_statements.rb:63:in `exec_insert'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapter

s/abstract/database_statements.rb:90:in `insert'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapter

s/abstract/query_cache.rb:14:in `insert'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/relation.rb:66:in 

`insert'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/persistence.rb:366

:in `create'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/timestamp.rb:57:in

 `create'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/callbacks.rb:268:i

n `block in create'

  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:403

:in `_run__4384089833700878333__create__735890728046573773__callbacks'

  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:405

:in `__run_callback'

  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:385

:in `_run_create_callbacks'

  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:81:

in `run_callbacks'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/callbacks.rb:268:i

n `create'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/persistence.rb:347

:in `create_or_update'
  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/callbacks.rb:264:i

n `block in create_or_update'

  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:436

:in `_run__4384089833700878333__save__735890728046573773__callbacks'

  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:405

:in `__run_callback'

  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:385

:in `_run_save_callbacks'

  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:81:

in `run_callbacks'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/callbacks.rb:264:i

n `create_or_update'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/persistence.rb:104

:in `save!'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/validations.rb:56:

in `save!'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/attribute_methods/

dirty.rb:33:in `save!'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:24

6:in `block in save!'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:29

5:in `block in with_transaction_returning_status'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapter

s/abstract/database_statements.rb:192:in `transaction'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:20

8:in `transaction'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:29

3:in `with_transaction_returning_status'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:24

6:in `save!'

  /usr/share/foreman/app/models/user_role.rb:58:in `each'

  /usr/share/foreman/app/models/user_role.rb:58:in `all?'

  /usr/share/foreman/app/models/user_role.rb:58:in `cache_user_roles!'

  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:449

:in `_run__4597219778037394767__save__735890728046573773__callbacks'

  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:405

:in `__run_callback'

  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:385

:in `_run_save_callbacks'

  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:81:

in `run_callbacks'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/callbacks.rb:264:i

n `create_or_update'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/persistence.rb:104

:in `save!'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/validations.rb:56:

in `save!'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/attribute_methods/

dirty.rb:33:in `save!'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:24

6:in `block in save!'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:29

5:in `block in with_transaction_returning_status'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapter

s/abstract/database_statements.rb:192:in `transaction'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:20

8:in `transaction'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:29

3:in `with_transaction_returning_status'

  /opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:24

6:in `save!'

  /usr/share/foreman/app/services/cache_manager.rb:9:in `map'

  /usr/share/foreman/app/services/cache_manager.rb:9:in `create_new_permission_cache'

  /usr/share/foreman/app/services/cache_manager.rb:19:in `recache!'

  /usr/share/foreman/config/initializers/fix_cache.rb:9:in `<top (required)>'

  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependencies.rb:

245:in `load'
  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependencies.rb:

245:in `block in load'

  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependencies.rb:

236:in `load_dependency'

  /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependencies.rb:

245:in `load'

  /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/engine.rb:588:in `block (2 lev

els) in <class:Engine>'

  /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/engine.rb:587:in `each'

  /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/engine.rb:587:in `block in <cl

ass:Engine>'

  /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/initializable.rb:30:in `instan

ce_exec'

  /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/initializable.rb:30:in `run'

  /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/initializable.rb:55:in `block 

in run_initializers'

  /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/initializable.rb:54:in `each'

  /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/initializable.rb:54:in `run_in

itializers'

  /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/application.rb:136:in `initial

ize!'

  /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/railtie/configurable.rb:30:in 

`method_missing'

  /usr/share/foreman/config/environment.rb:5:in `<top (required)>'

  /opt/rh/ruby193/root/usr/share/rubygems/rubygems/custom_require.rb:36:in `require'

  /opt/rh/ruby193/root/usr/share/rubygems/rubygems/custom_require.rb:36:in `require'

  config.ru:3:in `block in <main>'

  /opt/rh/ruby193/root/usr/share/gems/gems/rack-1.4.1/lib/rack/builder.rb:51:in `instance_eval'

  /opt/rh/ruby193/root/usr/share/gems/gems/rack-1.4.1/lib/rack/builder.rb:51:in `initialize'

  config.ru:1:in `new'

  config.ru:1:in `<main>'

  /usr/lib/ruby/gems/1.8/gems/passenger-4.0.18/helper-scripts/rack-preloader.rb:105:in `eval'

  /usr/lib/ruby/gems/1.8/gems/passenger-4.0.18/helper-scripts/rack-preloader.rb:105:in `preload_ap

p'

  /usr/lib/ruby/gems/1.8/gems/passenger-4.0.18/helper-scripts/rack-preloader.rb:150:in `<module:Ap

p>'

  /usr/lib/ruby/gems/1.8/gems/passenger-4.0.18/helper-scripts/rack-preloader.rb:29:in `<module:Phu

sionPassenger>'

  /usr/lib/ruby/gems/1.8/gems/passenger-4.0.18/helper-scripts/rack-preloader.rb:28:in `<main>'

 Looks similar to #4641, but could be unrelated.

Related issues:

Related to Foreman - Bug #6873: Error during db:seed from 1.4 to 1.6: undefin... Closed 08/01/2014

Related to Foreman - Refactor #6878: Replace default_scope with specific scop... New 08/01/2014

Associated revisions

Revision cad9cce9 - 08/10/2014 04:49 AM - Dominic Cleal

fixes #6964 - replace default scope that hides users with explicit scope

Revision eef2ba50 - 08/11/2014 08:27 AM - Dominic Cleal

fixes #6964 - replace default scope that hides users with explicit scope

(cherry picked from commit cad9cce912a371018a489a874d896af241f91bd0)

History

#1 - 08/06/2014 12:54 PM - Dominic Cleal

- Related to Bug #6873: Error during db:seed from 1.4 to 1.6: undefined method `expire_topbar_cache' for nil:NilClass added

#2 - 08/07/2014 12:00 PM - Dominic Cleal

- Blocked by Refactor #6878: Replace default_scope with specific scopes for visibility added

#3 - 08/07/2014 12:11 PM - Dominic Cleal

- Status changed from New to Assigned
- Assignee set to Dominic Cleal

#4 - 08/07/2014 12:59 PM - Dominic Cleal

- Blocked by deleted (Refactor #6878: Replace default_scope with specific scopes for visibility)

#5 - 08/07/2014 01:00 PM - Dominic Cleal

- Related to Refactor #6878: Replace default_scope with specific scopes for visibility added

#6 - 08/07/2014 01:00 PM - Dominic Cleal

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/1665 added

- Pull request deleted ()

#7 - 08/10/2014 08:01 AM - Dominic Cleal

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset cad9cce912a371018a489a874d896af241f91bd0.
